int FriendlyTIDCount;
int FriendlyTIDs[65535];

int CheckedTIDCount;
int CheckedTIDs[65535];

int Arc_IsZand;

#define ARCSCRIPT           192
#define ARCSCRIPT_SWITCH    193
#define ARCSCRIPT_BEAM      194

#define ARCCOUNT 3

//  =============================
//  == VERY IMPORTANT GOD DAMN ==
//  =============================
//
//  disable auto-unfriend only if you're firing multiple arcs at the same time,
//  and you don't want them to hit the same dudes multiple times
//
//  if you use this, make ABSOLUTELY SURE to run the clear-friendliness script
//  otherwise bad things with friendly, unkillable monsters will happen
//
//  the clear-friendliness script is ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 0)
//
//  it *must be* with WithResult, it *must be* all done in the same tic (don't even
//  try stretching it out over multiple tics), and it *must be* run immediately after
//  the last arc has fired, or else you'll get broken behavior
//
//  THE ARC CODE IS VERY DELICATE ALREADY
//
//  DISABLING AUTO-UNFRIENDLY MAKES THINGS EVEN MORE DELICATE
//
//  DO NOT FUCK IT UP
//
//  =============================
//  ==   STILL VERY IMPORTANT  ==
//  =============================

// =========
// == ALSO PRETTY IMPORTANT
//
// Doubling range quadruples the time arcs look around, as a rule of thumb.
//
// The difference between old look and new look is this:
//
// - old look just uses A_LookEx - it's faster, but it doesn't prioritize at all
//    and doesn't care about Z height, leading to unpredictable targeting behaviour
//
// - new look weighs in proximity and angle from arcer to create a more path-of-
//    least-resistance behaviour with the arcs
//  it gets slower and slower the more enemies are within range, since it does
//    A_LookEx for all of them; it's generally slower than old look

#define ARC_I_BEAMSCRIPT      0
#define ARC_I_BEAMSTART       1
#define ARC_I_BEAMDENSITY     2
#define ARC_I_ANGLEWEIGHT     3
#define ARC_I_AUTO_UNFRIEND   4
#define ARC_I_OLDLOOK         5

int ArcTypes_Int[ARCCOUNT][6] =
{
    {ARCSCRIPT_BEAM, 8,  16, 0.75, true,   false},
    {ARCSCRIPT_BEAM, 24, 16, 1.0,  true,   false},
    {ARCSCRIPT_BEAM, 8,  16, 0.25, false,  false},
};

#define ARC_S_POINT           0
#define ARC_S_BEAMACTOR       1

int ArcTypes_Str[ARCCOUNT][2] = 
{
    {"PopshotArc",              "PopshotTrail"},
    {"PopshotArc",              "PopshotTrail"},
    {"PopshotArc_ShortRange",   "PopshotTrail"},
};

#define NEAR_TID      0
#define NEAR_DIST     1
#define NEAR_PRIORITY 2
#define NEAR_X        3
#define NEAR_Y        4
#define NEAR_Z        5

int G_ARCNUM;
int G_FOUND;
int G_BESTTARGET[6];

