#include "zcommon.acs"
#library "harder"

#define MAXSECTORS  999 // If there's a map that has more tagged sectors than this, I don't want to fucking see it.
#define DELAYSECTOR 10000
#define PLAYERMAX 64

int flashlightOn[PLAYERMAX];

script 784 ENTER
{
    int heartbeat = 0;
    int pln = PlayerNumber();
    int invisTimer, oInvisTimer;
    int health, oHealth;

    GiveInventory("FlashlightStopper",1);
    flashlightOn[pln] = 0;

    FadeRange(0,0,0,1.00,0,0,0,0,3.50);
    while(1)
    {
        oHealth = health;
        health = GetActorProperty(0, APROP_Health);

        if (flashlightOn[pln])
            { GiveInventory("FlashlightSpawner",1); }

    // Heartbeat stuff.

        if (health < 26 && health > 0 && heartbeat >= 70)
            { FadeRange(205,0,0,0.15,0,0,0,0,0.75); LocalAmbientSound("player/heartbeat",127); heartbeat = 0; }
        else if (health > 25) { heartbeat = 0; }

    // Invis stuff.

        oInvisTimer = invisTimer;
        invisTimer  = CheckInventory("QuakeInvisTimer");

        if (invisTimer > 0)
        {
            if (invisTimer % 35 == 0 || oInvisTimer < invisTimer)
            {
                SetHudSize(320, 240, 1);
                SetFont("BIGFONT");
                HudMessage(d:(invisTimer+34) / 35;  HUDMSG_FADEOUT | HUDMSG_COLORSTRING, 58106, "Brick", 295.2, 0.5, 1.5, 1.0);
            }

            if (invisTimer % 105 == 0)
            {
                ActivatorSound("invis/whisper", 127);
            }

            if (invisTimer == 105)
            {
                LocalAmbientSound("invis/losing", 127);
            }

            if (oInvisTimer <= 0 || oHealth <= 0)
            {
                GiveInventory("QuakeInvisibility", 1);
                GiveInventory("QuakeSpeed",1);
                GiveInventory("QuakeGuard",1);
                FadeRange(0,0,0,1.0,0,0,0,0,1.0);
            }
        }
        else
        {
            if (oInvisTimer != 0)
            {
                HudMessage(s:""; HUDMSG_PLAIN, 58106, CR_UNTRANSLATED, 0, 0, 1);
                GiveInventory("QuakeInvisibilityOff",1);
                TakeInventory("QuakeSpeed",1);
                TakeInventory("QuakeGuard",1);
                FadeRange(0,0,0,0.75,0,0,0,0,1.0);
                LocalAmbientSound("invis/off", 127);
            }

        }

        if (InvisTimer > 0) { GiveInventory("ShadowFlicker",1); }

    // Catch-all stuff.

        GiveInventory("RainSpawner",1);
        TakeInventory("QuakeInvisTimer", 1);
        heartbeat++;

        if (health <= 0) // Ded
        {
            TakeInventory("QuakeInvisTimer", 0x7FFFFFFF);
            GiveInventory("FlashlightStopper",1);
            flashlightOn[pln] = 0;
            terminate;
        }

        delay(1);
    }
}

script 785 OPEN
{
    int sectorid;
    int lightlevel = GetCvar("h_darkness");

    if (GetCvar("h_music") == 0) { SetMusic("D_SILENT"); }
    ChangeSky("skypic1","skypic1");

    sectorid = 0;
    while(sectorid < MAXSECTORS)
    {
    if (GetSectorLightLevel(sectorid) > 0)
    {
        Light_Stop(sectorid);
        Sector_SetFade(sectorid, 0,0,0);
        Light_LowerByValue(sectorid,lightlevel);
    }
    sectorid++;
    delay(1);
    }
}

script 786 (void) NET // I can't believe I'm dedicating an entire script to this one instance.
{
    if (flashlightOn[PlayerNumber()])
    {
        flashlightOn[PlayerNumber()] = 0;
        GiveInventory("FlashlightStopper",1);
        ActivatorSound("flashlight/off", 127);
    }
    else
    {
        flashlightOn[PlayerNumber()] = 1;
        ActivatorSound("flashlight/on", 127);
    }
}

script 787 ENTER CLIENTSIDE // Well, this I at least have an excuse for.
{                           // If Z& supported Loop for PlaySound() then I wouldn't need to do this.
    while(1)
    {
        LocalAmbientSound("environment/rain",32);
        Delay(8*35);
        Delay(22);
    }
}

script 788 (int cocks)
{
    switch (cocks)
    {
      case 0:
        if (!CheckActorCeilingTexture(0, "F_SKY1")) { SetActorState(0,"Remove"); }
        break;

      case 1:
        Thing_ProjectileIntercept(0,"DoomImpBall",10,12000,0);
        break;
    }
}

script 789 DEATH
{
    if (GameType() == GAME_SINGLE_PLAYER)
    {
        delay(10);
        FadeRange(0,0,0,0.00,0,0,0,1.00,2.50);
    }
    else
    {
        AmbientSound("player/deathannounce",127);
    }
}

script 790 ENTER CLIENTSIDE // I REALLY CAN'T FUCKING WAIT UNTIL Z& SUPPORTS LOOP FOR PLAYSOUND
{                           // CAUSE THEN I CAN INTEGRATE THIS WITH 787
    int benis;
    int butts;

    Thing_ChangeTid(0,12000);
    delay(random(350,1050)); // Between 10 to 30 seconds.
    while(1)
    {
        benis = random(1,14);

        if (benis == 1) { LocalAmbientSound("darker/amb1",random(16,48)); }
        if (benis == 2) { LocalAmbientSound("darker/amb2",random(16,48)); delay(350); }
        if (benis == 3) { LocalAmbientSound("darker/amb3",random(16,48)); delay(105); }
        if (benis == 4)
        {
            butts = random(16,48);
            LocalAmbientSound("darker/amb4",butts);
            delay(35);
            LocalAmbientSound("darker/amb4",butts);
            delay(35);
            LocalAmbientSound("darker/amb4",butts);
            delay(35);
            LocalAmbientSound("darker/amb4",butts);
            delay(35);
        }
        if (benis == 5) { LocalAmbientSound("darker/amb5",random(16,48)); }
        if (benis == 6)
        {
            LocalAmbientSound("darker/amb6",random(16,48));
            delay(105);
        }
        if (benis == 7) { LocalAmbientSound("darker/amb7",random(16,48)); }
        if (benis == 8) { LocalAmbientSound("darker/amb8",random(16,48)); }
        if (benis == 9) { LocalAmbientSound("darker/amb9",random(16,48)); }
        if (benis == 10) { LocalAmbientSound("darker/amb11",random(16,48)); }
        delay(random(350,2100)); // Between ten seconds to a minute.
    }
}

script 791 ENTER
{
    int monstercount;
    int ghostcount = 0;
    int x, y, z;

    monstercount = GetLevelInfo(LEVELINFO_TOTAL_MONSTERS);
    
    x = GetActorX(0);
    y = GetActorY(0);
    z = GetActorZ(0);

    while (monstercount > ghostcount)
    {
        SpawnForced("RoamingSpirit",x,y,z,0,0);
        ghostcount++;
    }
}